<id>
Minimum Registration Time for YaBB 2.5/2.5.2
</id>

<version>
0.1.1
</version>

<mod info>
Description
-----------
This Mod will allow you to set a minimum amount of time which must be spent on the registration page. This should stop spambots which fill in the form in a time which is humanly impossible.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Go to Admin Center - Antispam Settings and hit 'Save' to enable the feature.

Files to edit
-------------
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Antispam.pl
Languages/English/Admin.lng
Languages/English/Register.lng
Sources/Register.pl

Version History
---------------
V0.1 - First release - 6th December 2012
V0.1.1 - Fixed problem with disabling the mod by setting a value of 0 - 10th December 2012
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$minregtime_mod = "Minimum Registration Time|Derek Barnstorm|This Mod will allow you to set a minimum amount of time which must be spent on the registration page. This should stop spambots which fill in the form in a time which is humanly impossible.|0.1.1|10th December 2012";
	push (@installed_mods, "$minregtime_mod");
	
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$speedpostdetection = $speedpostdetection;		# Set to 1 to detect speedposters and delay their spam actions
</search for>

<add before>
\$min_reg_time = $min_reg_time;    # Minimum amount of time to be spent filling out the registration form
</add before>

<edit file>
Admin/Settings_Antispam.pl
</edit file>

<search for>
$bdomains =~ s~,~\n~g;
</search for>

<add after>

$min_reg_time = 15 if $min_reg_time eq '';
</add after>

<search for>
			name => 'timeout',
			validate => 'number',
		},
</search for>

<add after>
		{
			description => qq~<label for="min_reg_time">$admin_txt{'min_reg_time'}</label>~,
			input_html => qq~<input type="text" name="min_reg_time" id="min_reg_time" size="4" value="$min_reg_time" />~,
			name => 'min_reg_time',
			validate => 'number',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'min_reg_time' => 'Minimum amount of time in seconds which must be spent on the registration page:<br /><span class="small">This is to stop spambots which automatically fill in the registration form in a time which is humanly impossible.<br />Set to 0 to disable.</span>',
</add before>

<edit file>
Languages/English/Register.lng
</edit file>

<search for>
'wrong_char' => 'This character in the Password is invalid',
</search for>

<add after>
'error_min_reg_time' => 'Your registration has been blocked due to security reasons. Please go back and try again.',
</add after>

<edit file>
Sources/Register.pl
</edit file>

<search for>
	my ($tmpregname, $tmprealname, $tmpregemail, $tmpregpasswrd1, $tmpregpasswrd2, $hidechecked, @birthdate);
</search for>

<replace>
	my ($tmpregname, $tmprealname, $tmpregemail, $tmpregpasswrd1, $tmpregpasswrd2, $hidechecked, $reg_start_time, @birthdate);
</replace>

<search for>
	if ($FORM{'birth_year'})  { $birthdate[2]   = $FORM{'birth_year'}; }
</search for>

<add after>
	if ($min_reg_time > 0)    { $reg_start_time = qq~<input type="hidden" name="reg_start_time" value="$date" />~; }
</add after>

<search for>
<form action="$scripturl?action=register2" method="post" name="creator" onsubmit="return CheckRegFields();">
</search for>

<add after>
$reg_start_time
</add after>

<search for>
	if ($regcheck) { require "$sourcedir/Decoder.pl"; &validation_check($member{'verification'}); }
</search for>

<add after>

    if ($min_reg_time > 0) {	
	    $reg_finish_time = $date - $member{'reg_start_time'};
	    if ($reg_finish_time < $min_reg_time || !$member{'reg_start_time'}) { &fatal_error("", "$register_txt{'error_min_reg_time'}"); }
	}
</add after>



